#ifndef ANIMAL_H
#define ANIMAL_H

#include <QLabel>

class Animal
{
    protected :
        // Pointeur vers un QLabel affichant une image de l'animal
        QLabel* ptrUI;

    public:
        // Méthode d'initialisation commune à tous les animaux
        void init();

        // Méthode virtuelle, qui n'est pas implémentée dans la classe
        // animal mais qui devra impérativement l'être dans les classes
        // filles
        virtual void avancer() = 0;

        // Destructeur
        virtual ~Animal();
};

class Lievre : public Animal {
    public :
        // Les classes filles ont leur constructeur
        Lievre(QLabel* label);

        // Méthode avencer qui est virtuelle dans la classe mère
        void avancer();

        // Destructeur
        ~Lievre();
};

class Tortue : public Animal {
    public :
        // Les classes filles ont leur constructeur
        Tortue(QLabel* label);

        // Méthode avencer qui est virtuelle dans la classe mère
        void avancer();

        // Destructeur
        ~Tortue();
};

#endif // ANIMAL_H
